/******/ (function(modules) { // webpackBootstrap
/******/ 	// The module cache
/******/ 	var installedModules = {};
/******/
/******/ 	// The require function
/******/ 	function __webpack_require__(moduleId) {
/******/
/******/ 		// Check if module is in cache
/******/ 		if(installedModules[moduleId]) {
/******/ 			return installedModules[moduleId].exports;
/******/ 		}
/******/ 		// Create a new module (and put it into the cache)
/******/ 		var module = installedModules[moduleId] = {
/******/ 			i: moduleId,
/******/ 			l: false,
/******/ 			exports: {}
/******/ 		};
/******/
/******/ 		// Execute the module function
/******/ 		modules[moduleId].call(module.exports, module, module.exports, __webpack_require__);
/******/
/******/ 		// Flag the module as loaded
/******/ 		module.l = true;
/******/
/******/ 		// Return the exports of the module
/******/ 		return module.exports;
/******/ 	}
/******/
/******/
/******/ 	// expose the modules object (__webpack_modules__)
/******/ 	__webpack_require__.m = modules;
/******/
/******/ 	// expose the module cache
/******/ 	__webpack_require__.c = installedModules;
/******/
/******/ 	// identity function for calling harmony imports with the correct context
/******/ 	__webpack_require__.i = function(value) { return value; };
/******/
/******/ 	// define getter function for harmony exports
/******/ 	__webpack_require__.d = function(exports, name, getter) {
/******/ 		if(!__webpack_require__.o(exports, name)) {
/******/ 			Object.defineProperty(exports, name, {
/******/ 				configurable: false,
/******/ 				enumerable: true,
/******/ 				get: getter
/******/ 			});
/******/ 		}
/******/ 	};
/******/
/******/ 	// getDefaultExport function for compatibility with non-harmony modules
/******/ 	__webpack_require__.n = function(module) {
/******/ 		var getter = module && module.__esModule ?
/******/ 			function getDefault() { return module['default']; } :
/******/ 			function getModuleExports() { return module; };
/******/ 		__webpack_require__.d(getter, 'a', getter);
/******/ 		return getter;
/******/ 	};
/******/
/******/ 	// Object.prototype.hasOwnProperty.call
/******/ 	__webpack_require__.o = function(object, property) { return Object.prototype.hasOwnProperty.call(object, property); };
/******/
/******/ 	// __webpack_public_path__
/******/ 	__webpack_require__.p = "";
/******/
/******/ 	// Load entry module and return exports
/******/ 	return __webpack_require__(__webpack_require__.s = 1);
/******/ })
/************************************************************************/
/******/ ([
/* 0 */
/***/ (function(module, exports) {

// shim for using process in browser
var process = module.exports = {};

// cached from whatever global is present so that test runners that stub it
// don't break things.  But we need to wrap it in a try catch in case it is
// wrapped in strict mode code which doesn't define any globals.  It's inside a
// function because try/catches deoptimize in certain engines.

var cachedSetTimeout;
var cachedClearTimeout;

function defaultSetTimout() {
    throw new Error('setTimeout has not been defined');
}
function defaultClearTimeout () {
    throw new Error('clearTimeout has not been defined');
}
(function () {
    try {
        if (typeof setTimeout === 'function') {
            cachedSetTimeout = setTimeout;
        } else {
            cachedSetTimeout = defaultSetTimout;
        }
    } catch (e) {
        cachedSetTimeout = defaultSetTimout;
    }
    try {
        if (typeof clearTimeout === 'function') {
            cachedClearTimeout = clearTimeout;
        } else {
            cachedClearTimeout = defaultClearTimeout;
        }
    } catch (e) {
        cachedClearTimeout = defaultClearTimeout;
    }
} ())
function runTimeout(fun) {
    if (cachedSetTimeout === setTimeout) {
        //normal enviroments in sane situations
        return setTimeout(fun, 0);
    }
    // if setTimeout wasn't available but was latter defined
    if ((cachedSetTimeout === defaultSetTimout || !cachedSetTimeout) && setTimeout) {
        cachedSetTimeout = setTimeout;
        return setTimeout(fun, 0);
    }
    try {
        // when when somebody has screwed with setTimeout but no I.E. maddness
        return cachedSetTimeout(fun, 0);
    } catch(e){
        try {
            // When we are in I.E. but the script has been evaled so I.E. doesn't trust the global object when called normally
            return cachedSetTimeout.call(null, fun, 0);
        } catch(e){
            // same as above but when it's a version of I.E. that must have the global object for 'this', hopfully our context correct otherwise it will throw a global error
            return cachedSetTimeout.call(this, fun, 0);
        }
    }


}
function runClearTimeout(marker) {
    if (cachedClearTimeout === clearTimeout) {
        //normal enviroments in sane situations
        return clearTimeout(marker);
    }
    // if clearTimeout wasn't available but was latter defined
    if ((cachedClearTimeout === defaultClearTimeout || !cachedClearTimeout) && clearTimeout) {
        cachedClearTimeout = clearTimeout;
        return clearTimeout(marker);
    }
    try {
        // when when somebody has screwed with setTimeout but no I.E. maddness
        return cachedClearTimeout(marker);
    } catch (e){
        try {
            // When we are in I.E. but the script has been evaled so I.E. doesn't  trust the global object when called normally
            return cachedClearTimeout.call(null, marker);
        } catch (e){
            // same as above but when it's a version of I.E. that must have the global object for 'this', hopfully our context correct otherwise it will throw a global error.
            // Some versions of I.E. have different rules for clearTimeout vs setTimeout
            return cachedClearTimeout.call(this, marker);
        }
    }



}
var queue = [];
var draining = false;
var currentQueue;
var queueIndex = -1;

function cleanUpNextTick() {
    if (!draining || !currentQueue) {
        return;
    }
    draining = false;
    if (currentQueue.length) {
        queue = currentQueue.concat(queue);
    } else {
        queueIndex = -1;
    }
    if (queue.length) {
        drainQueue();
    }
}

function drainQueue() {
    if (draining) {
        return;
    }
    var timeout = runTimeout(cleanUpNextTick);
    draining = true;

    var len = queue.length;
    while(len) {
        currentQueue = queue;
        queue = [];
        while (++queueIndex < len) {
            if (currentQueue) {
                currentQueue[queueIndex].run();
            }
        }
        queueIndex = -1;
        len = queue.length;
    }
    currentQueue = null;
    draining = false;
    runClearTimeout(timeout);
}

process.nextTick = function (fun) {
    var args = new Array(arguments.length - 1);
    if (arguments.length > 1) {
        for (var i = 1; i < arguments.length; i++) {
            args[i - 1] = arguments[i];
        }
    }
    queue.push(new Item(fun, args));
    if (queue.length === 1 && !draining) {
        runTimeout(drainQueue);
    }
};

// v8 likes predictible objects
function Item(fun, array) {
    this.fun = fun;
    this.array = array;
}
Item.prototype.run = function () {
    this.fun.apply(null, this.array);
};
process.title = 'browser';
process.browser = true;
process.env = {};
process.argv = [];
process.version = ''; // empty string to avoid regexp issues
process.versions = {};

function noop() {}

process.on = noop;
process.addListener = noop;
process.once = noop;
process.off = noop;
process.removeListener = noop;
process.removeAllListeners = noop;
process.emit = noop;
process.prependListener = noop;
process.prependOnceListener = noop;

process.listeners = function (name) { return [] }

process.binding = function (name) {
    throw new Error('process.binding is not supported');
};

process.cwd = function () { return '/' };
process.chdir = function (dir) {
    throw new Error('process.chdir is not supported');
};
process.umask = function() { return 0; };


/***/ }),
/* 1 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
Object.defineProperty(__webpack_exports__, "__esModule", { value: true });
/* WEBPACK VAR INJECTION */(function(process) {class Log {
  constructor(config = {}) {
    this.config = config;
    this._window = config.window;
    this.init();
  }
  init() {
    this.windowError();
    this.resourceError();
    this.Console();
    this.ajaxError();
  }
  windowError() {
    let that = this;
    if (that.config.Vue && that.config.Vue.config) {
      const Vue = that.config.Vue;
      Vue.config.errorHandler = function (err, vm, info) {
        console.error(1213, err.line, err.col, err.msg, err.stack);
        that.config.sendError({
          title: 'vue Error',
          msg: JSON.stringify(err.stack),
          url: that._window.location.href,
          type: 'js'
        });
      };
    }
    that._window.onerror = function (msg, url, line, col, error) {
      console.error(msg, url, line, col, error);
      if (error && error.stack) {
        that.config.sendError({
          title: msg,
          msg: JSON.stringify(error.stack),
          url: that._window.location.href,
          type: 'js'
        });
      } else if (typeof msg === 'string') {
        that.config.sendError({
          title: msg,
          msg: JSON.stringify(msg),
          url: that._window.location.href,
          type: 'js'
        });
      }
    };
  }
  resourceError() {
    let that = this;
    that._window.addEventListener('error', function (event) {
      if (event) {
        let target = event.target || event.srcElement;
        let isElementTarget = target instanceof HTMLScriptElement || target instanceof HTMLImageElement || target instanceof HTMLLinkElement;

        if (!isElementTarget) return false;

        that.config.sendError({
          title: target.nodeName,
          msg: target.outerHTML,
          url: that._window.location.href,
          type: 'resource'
        });
      }
    }, true);
  }
  ajaxError() {
    let that = this;
    interceptAjax(that, {
      open: function (arg, xhr) {
        this.ajaxObj.type = arg[0];
        this.ajaxObj.url = arg[1];
        this.ajaxObj.async = arg[2];
      },
      send: function (arg, xhr) {
        let type = this.ajaxObj.type;
        if (type === 'POST') {
          this.ajaxObj.data = JSON.parse(arg[0] || null);
        } else {
          let url = this.ajaxObj.url;
          let params = url.slice(url.indexOf('?') + 1);
          let data = {};
          params.split('&').forEach(item => {
            let v = item.split('=');
            data[v[0]] = v[1];
          });
          this.ajaxObj.data = data;
        }
      },
      onreadystatechange: function (res) {
        xhrOnloadFn(res);
      },
      onload: function (res) {
        xhrOnloadFn(res);
      }
    });
    function xhrOnloadFn(res) {
      let xhr = res.xhr;
      if (xhr && xhr.readyState === 4) {
        res.ajaxObj.status = xhr.status;
        res.ajaxObj.responseURL = xhr.responseURL || '';
        res.ajaxObj.responseHeaders = res.getAllResponseHeaders();
        try {
          res.ajaxObj.response = JSON.parse(xhr.response) || JSON.parse(xhr.responseText);
        } catch (e) {
          res.ajaxObj.response = xhr.response || xhr.responseText;
        }

        let filterUrl = that.config.filterHttpUrl || [];
        let hasAbort = false;

        if (typeof filterUrl === 'string') {
          hasAbort = res.ajaxObj.responseURL.includes(filterUrl);
        } else {
          filterUrl.forEach(item => {
            if (res.ajaxObj.responseURL.includes(item)) {
              hasAbort = true;
            }
          });
        }

        if (!hasAbort) {
          that.config.sendError({
            title: 'ajaxMsg',
            msg: JSON.stringify(res.ajaxObj),
            url: that._window.location.href,
            type: 'ajax'
          });
        }
      }
    }
  }
  Console() {
    const that = this;
    const _window = that._window;
    let consoleLog = _window.console.log;
    if (consoleLog) {
      _window.log = function () {
        consoleLog.apply(_window, arguments);
        try {
          if (process.env.NODE_ENV === 'development') {
            consoleLog.apply(_window, arguments);
          }
        } catch (e) {
          consoleLog.apply(_window, arguments);
        }
        that.config.sendError({
          title: 'consoleLog',
          msg: JSON.stringify([...arguments]),
          url: that._window.location.href,
          type: 'console'
        });
      };
    }
  }
}

const interceptAjax = function (that, proxy) {
  that._window._privatexhr = that._window._privatexhr || XMLHttpRequest;
  XMLHttpRequest = function () {
    this.xhr = new that._window._privatexhr();
    this.ajaxObj = {};
    for (let attr in this.xhr) {
      let type = typeof this.xhr[attr];
      if (type === 'function') {
        this[attr] = interceptFun(attr);
      } else {
        Object.defineProperty(this, attr, {
          get: getIntercept(attr),
          set: setIntercept(attr)
        });
      }
    }
  };

  function getIntercept(attr) {
    return function () {
      var v = this.hasOwnProperty(attr + "_") ? this[attr + "_"] : this.xhr[attr];
      var attrGetterHook = (proxy[attr] || {})["getter"];
      return attrGetterHook && attrGetterHook(v, this) || v;
    };
  }

  function setIntercept(attr) {
    return function (v) {
      var xhr = this.xhr;
      var that = this;
      var hook = proxy[attr];
      if (typeof hook === "function") {
        xhr[attr] = function () {
          proxy[attr](that) || v.apply(xhr, arguments);
        };
      }
    };
  }

  function interceptFun(fun) {
    return function () {
      const args = [].slice.call(arguments);
      if (proxy[fun] && proxy[fun].call(this, args, this.xhr)) return false;
      return this.xhr[fun].apply(this.xhr, args);
    };
  }
};
/* harmony export (immutable) */ __webpack_exports__["interceptAjax"] = interceptAjax;


/* harmony default export */ __webpack_exports__["default"] = (Log);
/* WEBPACK VAR INJECTION */}.call(__webpack_exports__, __webpack_require__(0)))

/***/ })
/******/ ]);